<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAttivitaUtente ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAttivitaUtente
 * @subpackage Arrays
 */
class ArrayOfAttivitaUtente extends AbstractStructArrayBase
{
    /**
     * The AttivitaUtente
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AttivitaUtente[]
     */
    public $AttivitaUtente;
    /**
     * Constructor method for ArrayOfAttivitaUtente
     * @uses ArrayOfAttivitaUtente::setAttivitaUtente()
     * @param \StructType\AttivitaUtente[] $attivitaUtente
     */
    public function __construct(array $attivitaUtente = array())
    {
        $this
            ->setAttivitaUtente($attivitaUtente);
    }
    /**
     * Get AttivitaUtente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AttivitaUtente[]|null
     */
    public function getAttivitaUtente()
    {
        return isset($this->AttivitaUtente) ? $this->AttivitaUtente : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAttivitaUtente method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAttivitaUtente method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAttivitaUtenteForArrayConstraintsFromSetAttivitaUtente(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAttivitaUtenteAttivitaUtenteItem) {
            // validation for constraint: itemType
            if (!$arrayOfAttivitaUtenteAttivitaUtenteItem instanceof \StructType\AttivitaUtente) {
                $invalidValues[] = is_object($arrayOfAttivitaUtenteAttivitaUtenteItem) ? get_class($arrayOfAttivitaUtenteAttivitaUtenteItem) : sprintf('%s(%s)', gettype($arrayOfAttivitaUtenteAttivitaUtenteItem), var_export($arrayOfAttivitaUtenteAttivitaUtenteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AttivitaUtente property can only contain items of type \StructType\AttivitaUtente, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AttivitaUtente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AttivitaUtente[] $attivitaUtente
     * @return \ArrayType\ArrayOfAttivitaUtente
     */
    public function setAttivitaUtente(array $attivitaUtente = array())
    {
        // validation for constraint: array
        if ('' !== ($attivitaUtenteArrayErrorMessage = self::validateAttivitaUtenteForArrayConstraintsFromSetAttivitaUtente($attivitaUtente))) {
            throw new \InvalidArgumentException($attivitaUtenteArrayErrorMessage, __LINE__);
        }
        if (is_null($attivitaUtente) || (is_array($attivitaUtente) && empty($attivitaUtente))) {
            unset($this->AttivitaUtente);
        } else {
            $this->AttivitaUtente = $attivitaUtente;
        }
        return $this;
    }
    /**
     * Add item to AttivitaUtente value
     * @throws \InvalidArgumentException
     * @param \StructType\AttivitaUtente $item
     * @return \ArrayType\ArrayOfAttivitaUtente
     */
    public function addToAttivitaUtente(\StructType\AttivitaUtente $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AttivitaUtente) {
            throw new \InvalidArgumentException(sprintf('The AttivitaUtente property can only contain items of type \StructType\AttivitaUtente, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AttivitaUtente[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AttivitaUtente|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AttivitaUtente|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AttivitaUtente|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AttivitaUtente|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AttivitaUtente|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AttivitaUtente
     */
    public function getAttributeName()
    {
        return 'AttivitaUtente';
    }
}
