<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRichiestaCartellino ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRichiestaCartellino
 * @subpackage Arrays
 */
class ArrayOfRichiestaCartellino extends AbstractStructArrayBase
{
    /**
     * The RichiestaCartellino
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RichiestaCartellino[]
     */
    public $RichiestaCartellino;
    /**
     * Constructor method for ArrayOfRichiestaCartellino
     * @uses ArrayOfRichiestaCartellino::setRichiestaCartellino()
     * @param \StructType\RichiestaCartellino[] $richiestaCartellino
     */
    public function __construct(array $richiestaCartellino = array())
    {
        $this
            ->setRichiestaCartellino($richiestaCartellino);
    }
    /**
     * Get RichiestaCartellino value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RichiestaCartellino[]|null
     */
    public function getRichiestaCartellino()
    {
        return isset($this->RichiestaCartellino) ? $this->RichiestaCartellino : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRichiestaCartellino method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRichiestaCartellino method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRichiestaCartellinoForArrayConstraintsFromSetRichiestaCartellino(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRichiestaCartellinoRichiestaCartellinoItem) {
            // validation for constraint: itemType
            if (!$arrayOfRichiestaCartellinoRichiestaCartellinoItem instanceof \StructType\RichiestaCartellino) {
                $invalidValues[] = is_object($arrayOfRichiestaCartellinoRichiestaCartellinoItem) ? get_class($arrayOfRichiestaCartellinoRichiestaCartellinoItem) : sprintf('%s(%s)', gettype($arrayOfRichiestaCartellinoRichiestaCartellinoItem), var_export($arrayOfRichiestaCartellinoRichiestaCartellinoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RichiestaCartellino property can only contain items of type \StructType\RichiestaCartellino, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RichiestaCartellino value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RichiestaCartellino[] $richiestaCartellino
     * @return \ArrayType\ArrayOfRichiestaCartellino
     */
    public function setRichiestaCartellino(array $richiestaCartellino = array())
    {
        // validation for constraint: array
        if ('' !== ($richiestaCartellinoArrayErrorMessage = self::validateRichiestaCartellinoForArrayConstraintsFromSetRichiestaCartellino($richiestaCartellino))) {
            throw new \InvalidArgumentException($richiestaCartellinoArrayErrorMessage, __LINE__);
        }
        if (is_null($richiestaCartellino) || (is_array($richiestaCartellino) && empty($richiestaCartellino))) {
            unset($this->RichiestaCartellino);
        } else {
            $this->RichiestaCartellino = $richiestaCartellino;
        }
        return $this;
    }
    /**
     * Add item to RichiestaCartellino value
     * @throws \InvalidArgumentException
     * @param \StructType\RichiestaCartellino $item
     * @return \ArrayType\ArrayOfRichiestaCartellino
     */
    public function addToRichiestaCartellino(\StructType\RichiestaCartellino $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RichiestaCartellino) {
            throw new \InvalidArgumentException(sprintf('The RichiestaCartellino property can only contain items of type \StructType\RichiestaCartellino, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RichiestaCartellino[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RichiestaCartellino|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RichiestaCartellino|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RichiestaCartellino|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RichiestaCartellino|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RichiestaCartellino|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RichiestaCartellino
     */
    public function getAttributeName()
    {
        return 'RichiestaCartellino';
    }
}
