<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InviaPresenza_Request StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:InviaPresenza_Request
 * @subpackage Structs
 */
class InviaPresenza_Request extends AbstractStructBase
{
    /**
     * The Attivita
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AttivitaModel
     */
    public $Attivita;
    /**
     * The Presenza
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PresenzaModel
     */
    public $Presenza;
    /**
     * The RisposteCheckList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfPresenza_CheckListRispostaModel
     */
    public $RisposteCheckList;
    /**
     * The Sezione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Sezione_Model
     */
    public $Sezione;
    /**
     * Constructor method for InviaPresenza_Request
     * @uses InviaPresenza_Request::setAttivita()
     * @uses InviaPresenza_Request::setPresenza()
     * @uses InviaPresenza_Request::setRisposteCheckList()
     * @uses InviaPresenza_Request::setSezione()
     * @param \StructType\AttivitaModel $attivita
     * @param \StructType\PresenzaModel $presenza
     * @param \ArrayType\ArrayOfPresenza_CheckListRispostaModel $risposteCheckList
     * @param \StructType\Sezione_Model $sezione
     */
    public function __construct(\StructType\AttivitaModel $attivita = null, \StructType\PresenzaModel $presenza = null, \ArrayType\ArrayOfPresenza_CheckListRispostaModel $risposteCheckList = null, \StructType\Sezione_Model $sezione = null)
    {
        $this
            ->setAttivita($attivita)
            ->setPresenza($presenza)
            ->setRisposteCheckList($risposteCheckList)
            ->setSezione($sezione);
    }
    /**
     * Get Attivita value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AttivitaModel|null
     */
    public function getAttivita()
    {
        return isset($this->Attivita) ? $this->Attivita : null;
    }
    /**
     * Set Attivita value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\AttivitaModel $attivita
     * @return \StructType\InviaPresenza_Request
     */
    public function setAttivita(\StructType\AttivitaModel $attivita = null)
    {
        if (is_null($attivita) || (is_array($attivita) && empty($attivita))) {
            unset($this->Attivita);
        } else {
            $this->Attivita = $attivita;
        }
        return $this;
    }
    /**
     * Get Presenza value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PresenzaModel|null
     */
    public function getPresenza()
    {
        return isset($this->Presenza) ? $this->Presenza : null;
    }
    /**
     * Set Presenza value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PresenzaModel $presenza
     * @return \StructType\InviaPresenza_Request
     */
    public function setPresenza(\StructType\PresenzaModel $presenza = null)
    {
        if (is_null($presenza) || (is_array($presenza) && empty($presenza))) {
            unset($this->Presenza);
        } else {
            $this->Presenza = $presenza;
        }
        return $this;
    }
    /**
     * Get RisposteCheckList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfPresenza_CheckListRispostaModel|null
     */
    public function getRisposteCheckList()
    {
        return isset($this->RisposteCheckList) ? $this->RisposteCheckList : null;
    }
    /**
     * Set RisposteCheckList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfPresenza_CheckListRispostaModel $risposteCheckList
     * @return \StructType\InviaPresenza_Request
     */
    public function setRisposteCheckList(\ArrayType\ArrayOfPresenza_CheckListRispostaModel $risposteCheckList = null)
    {
        if (is_null($risposteCheckList) || (is_array($risposteCheckList) && empty($risposteCheckList))) {
            unset($this->RisposteCheckList);
        } else {
            $this->RisposteCheckList = $risposteCheckList;
        }
        return $this;
    }
    /**
     * Get Sezione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Sezione_Model|null
     */
    public function getSezione()
    {
        return isset($this->Sezione) ? $this->Sezione : null;
    }
    /**
     * Set Sezione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Sezione_Model $sezione
     * @return \StructType\InviaPresenza_Request
     */
    public function setSezione(\StructType\Sezione_Model $sezione = null)
    {
        if (is_null($sezione) || (is_array($sezione) && empty($sezione))) {
            unset($this->Sezione);
        } else {
            $this->Sezione = $sezione;
        }
        return $this;
    }
}
