<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InviaPresenza_Response StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:InviaPresenza_Response
 * @subpackage Structs
 */
class InviaPresenza_Response extends WebService_GenericResult
{
    /**
     * The Presenza
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PresenzaModel
     */
    public $Presenza;
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Result;
    /**
     * The Result_Descr
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Result_Descr;
    /**
     * Constructor method for InviaPresenza_Response
     * @uses InviaPresenza_Response::setPresenza()
     * @uses InviaPresenza_Response::setResult()
     * @uses InviaPresenza_Response::setResult_Descr()
     * @param \StructType\PresenzaModel $presenza
     * @param string $result
     * @param string $result_Descr
     */
    public function __construct(\StructType\PresenzaModel $presenza = null, $result = null, $result_Descr = null)
    {
        $this
            ->setPresenza($presenza)
            ->setResult($result)
            ->setResult_Descr($result_Descr);
    }
    /**
     * Get Presenza value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PresenzaModel|null
     */
    public function getPresenza()
    {
        return isset($this->Presenza) ? $this->Presenza : null;
    }
    /**
     * Set Presenza value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PresenzaModel $presenza
     * @return \StructType\InviaPresenza_Response
     */
    public function setPresenza(\StructType\PresenzaModel $presenza = null)
    {
        if (is_null($presenza) || (is_array($presenza) && empty($presenza))) {
            unset($this->Presenza);
        } else {
            $this->Presenza = $presenza;
        }
        return $this;
    }
    /**
     * Get Result value
     * @return string|null
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @uses \EnumType\InviaPresenza_Results::valueIsValid()
     * @uses \EnumType\InviaPresenza_Results::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $result
     * @return \StructType\InviaPresenza_Response
     */
    public function setResult($result = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\InviaPresenza_Results::valueIsValid($result)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\InviaPresenza_Results', is_array($result) ? implode(', ', $result) : var_export($result, true), implode(', ', \EnumType\InviaPresenza_Results::getValidValues())), __LINE__);
        }
        $this->Result = $result;
        return $this;
    }
    /**
     * Get Result_Descr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getResult_Descr()
    {
        return isset($this->Result_Descr) ? $this->Result_Descr : null;
    }
    /**
     * Set Result_Descr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $result_Descr
     * @return \StructType\InviaPresenza_Response
     */
    public function setResult_Descr($result_Descr = null)
    {
        // validation for constraint: string
        if (!is_null($result_Descr) && !is_string($result_Descr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($result_Descr, true), gettype($result_Descr)), __LINE__);
        }
        if (is_null($result_Descr) || (is_array($result_Descr) && empty($result_Descr))) {
            unset($this->Result_Descr);
        } else {
            $this->Result_Descr = $result_Descr;
        }
        return $this;
    }
}
