<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Login_EasyGAV_Web_Result StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Login_EasyGAV_Web_Result
 * @subpackage Structs
 */
class Login_EasyGAV_Web_Result extends AbstractStructBase
{
    /**
     * The AuthToken
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AuthToken;
    /**
     * The ConfigurazioneApp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ConfigurazioneApp
     */
    public $ConfigurazioneApp;
    /**
     * The Informazioni
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AdditionaInformation
     */
    public $Informazioni;
    /**
     * Constructor method for Login_EasyGAV_Web_Result
     * @uses Login_EasyGAV_Web_Result::setAuthToken()
     * @uses Login_EasyGAV_Web_Result::setConfigurazioneApp()
     * @uses Login_EasyGAV_Web_Result::setInformazioni()
     * @param string $authToken
     * @param \StructType\ConfigurazioneApp $configurazioneApp
     * @param \StructType\AdditionaInformation $informazioni
     */
    public function __construct($authToken = null, \StructType\ConfigurazioneApp $configurazioneApp = null, \StructType\AdditionaInformation $informazioni = null)
    {
        $this
            ->setAuthToken($authToken)
            ->setConfigurazioneApp($configurazioneApp)
            ->setInformazioni($informazioni);
    }
    /**
     * Get AuthToken value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAuthToken()
    {
        return isset($this->AuthToken) ? $this->AuthToken : null;
    }
    /**
     * Set AuthToken value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $authToken
     * @return \StructType\Login_EasyGAV_Web_Result
     */
    public function setAuthToken($authToken = null)
    {
        // validation for constraint: string
        if (!is_null($authToken) && !is_string($authToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($authToken, true), gettype($authToken)), __LINE__);
        }
        if (is_null($authToken) || (is_array($authToken) && empty($authToken))) {
            unset($this->AuthToken);
        } else {
            $this->AuthToken = $authToken;
        }
        return $this;
    }
    /**
     * Get ConfigurazioneApp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ConfigurazioneApp|null
     */
    public function getConfigurazioneApp()
    {
        return isset($this->ConfigurazioneApp) ? $this->ConfigurazioneApp : null;
    }
    /**
     * Set ConfigurazioneApp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ConfigurazioneApp $configurazioneApp
     * @return \StructType\Login_EasyGAV_Web_Result
     */
    public function setConfigurazioneApp(\StructType\ConfigurazioneApp $configurazioneApp = null)
    {
        if (is_null($configurazioneApp) || (is_array($configurazioneApp) && empty($configurazioneApp))) {
            unset($this->ConfigurazioneApp);
        } else {
            $this->ConfigurazioneApp = $configurazioneApp;
        }
        return $this;
    }
    /**
     * Get Informazioni value
     * @return \StructType\AdditionaInformation|null
     */
    public function getInformazioni()
    {
        return $this->Informazioni;
    }
    /**
     * Set Informazioni value
     * @param \StructType\AdditionaInformation $informazioni
     * @return \StructType\Login_EasyGAV_Web_Result
     */
    public function setInformazioni(\StructType\AdditionaInformation $informazioni = null)
    {
        $this->Informazioni = $informazioni;
        return $this;
    }
}
