<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Quota_Model StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Quota_Model
 * @subpackage Structs
 */
class Quota_Model extends AbstractStructBase
{
    /**
     * The Descrizione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Descrizione;
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ID;
    /**
     * The Importo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Importo;
    /**
     * Constructor method for Quota_Model
     * @uses Quota_Model::setDescrizione()
     * @uses Quota_Model::setID()
     * @uses Quota_Model::setImporto()
     * @param string $descrizione
     * @param int $iD
     * @param float $importo
     */
    public function __construct($descrizione = null, $iD = null, $importo = null)
    {
        $this
            ->setDescrizione($descrizione)
            ->setID($iD)
            ->setImporto($importo);
    }
    /**
     * Get Descrizione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescrizione()
    {
        return isset($this->Descrizione) ? $this->Descrizione : null;
    }
    /**
     * Set Descrizione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descrizione
     * @return \StructType\Quota_Model
     */
    public function setDescrizione($descrizione = null)
    {
        // validation for constraint: string
        if (!is_null($descrizione) && !is_string($descrizione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descrizione, true), gettype($descrizione)), __LINE__);
        }
        if (is_null($descrizione) || (is_array($descrizione) && empty($descrizione))) {
            unset($this->Descrizione);
        } else {
            $this->Descrizione = $descrizione;
        }
        return $this;
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\Quota_Model
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !(is_int($iD) || ctype_digit($iD))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Importo value
     * @return float|null
     */
    public function getImporto()
    {
        return $this->Importo;
    }
    /**
     * Set Importo value
     * @param float $importo
     * @return \StructType\Quota_Model
     */
    public function setImporto($importo = null)
    {
        // validation for constraint: float
        if (!is_null($importo) && !(is_float($importo) || is_numeric($importo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($importo, true), gettype($importo)), __LINE__);
        }
        $this->Importo = $importo;
        return $this;
    }
}
